#include <amxmodx>
#include <nvault>

native csgom_set_goldmoney(id, value)
native csgom_get_goldmoney(id)

new g_szAuthId[33][35], g_szDay[3], g_iVault, g_iDay

public plugin_init()
{
	register_plugin("Daily Login Reward", "1.0", "EFFEX")
	
	register_clcmd("say /reward", "cmdReward")
	get_time("%d", g_szDay, charsmax(g_szDay))
	
	g_iDay = str_to_num(g_szDay)
	g_iVault = nvault_open("DailyRewards")
}

public cmdReward(id)
{
	get_user_authid(id, g_szAuthId[id], charsmax(g_szAuthId[]))
	
	new iDay = nvault_get(g_iVault, g_szAuthId[id])
	if(iDay == g_iDay)
	{
		ChatColor(id, "^x04[EFFEX S]^x01 You already used your daily reward.")
		return PLUGIN_HANDLED
	}

	if(!iDay || iDay != g_iDay)
	{
		new szBonus[32], szName[32], iRandom = random_num(1, 5)
		get_user_name(id, szName, charsmax(szName))
		switch(random_num(0, 3))
		{
			case 0:	
			{
				server_cmd("amx_set_case ^"%s^" %d", szName, iRandom)
				formatex(szBonus, charsmax(szBonus), "%d case%s", iRandom, (iRandom > 1) ? "s" : "")
			}
			case 1:	
			{
				server_cmd("amx_set_key ^"%s^" %d", szName, iRandom)
				formatex(szBonus, charsmax(szBonus), "%d key%s", iRandom, (iRandom > 1) ? "s" : "")
			}
			case 2:	
			{
				iRandom *= random_num(5, 10)
				server_cmd("amx_set_csgoc ^"%s^" %d", szName, iRandom)
				formatex(szBonus, charsmax(szBonus), "%d CSGO Coin%s", iRandom, (iRandom > 1) ? "s" : "")
			}
			case 3:
			{
				iRandom *= random_num(2, 15)
				csgom_set_goldmoney(id, csgom_get_goldmoney(id) + iRandom)
				formatex(szBonus, charsmax(szBonus), "%d CSGO Coin%s", iRandom, (iRandom > 1) ? "s" : "")
			}
		}
		set_hudmessage(255, 165, 0, 0.02, 0.73, 0, 6.0, 4.0)
		show_hudmessage(id, "You received %s!", szBonus)
		
		ChatColor(id, "^x04[EFFEX S]^x01 Congratulations, you received^x04 %s!", szBonus)
		nvault_set(g_iVault, g_szAuthId[id], g_szDay) 
	}
	return PLUGIN_HANDLED
}
	
ChatColor(const id, const input[], any:...)
{
        new count = 1, players[32]
        static msg[191]
        vformat(msg, 190, input, 3)

        replace_all(msg, 190, "!g", "^4") // verde
        replace_all(msg, 190, "!y", "^1") // Default
        replace_all(msg, 190, "!t", "^3") // Team

        if (id) players[0] = id; else get_players(players, count, "ch")
        {
                for (new i = 0; i < count; i++)
                {
                        if (is_user_connected(players[i]))
                        {
                                message_begin(MSG_ONE_UNRELIABLE, get_user_msgid("SayText"), _, players[i])
                                write_byte(players[i]);
                                write_string(msg);
                                message_end();
                        }
                }
        }
}
