#include <amxmodx>
#include <amxmisc>
#include <nvault>

#if AMXX_VERSION_NUM < 183
#define client_disconnected		client_disconnect
#endif

#define PLUGIN "Played Time"
#define VERSION "1.3"
#define AUTHOR "Alka"

new TotalPlayedTime[33];
new valut

public plugin_init() 
{
	register_plugin(PLUGIN, VERSION, AUTHOR );

	register_event("HLTV", "event_round_start", "a", "1=0", "2=0")
	valut = nvault_open("Time_played")
}

public plugin_end() nvault_close(valut)

public plugin_natives()
{
	register_native("getUserActivity", "_get", 1)
}

public _get(id) return (get_user_time(id, 1) / 60) + TotalPlayedTime[id]

public event_round_start()
{
	new iPlayers[32], iNum
	get_players(iPlayers, iNum, "ch")
	for(new i;i < iNum;i++)
	{
		saveUserTime(iPlayers[i])
	}
}

public client_disconnected(id)
{
	saveUserTime(id)
}

saveUserTime(id)
{
	TotalPlayedTime[id] += (get_user_time(id) / 60)
	SaveTime(id, TotalPlayedTime[id]);
}

public client_connect(id)
{
	TotalPlayedTime[id] = LoadTime(id)
}

LoadTime(id) 
{
	new authid[35]
	get_user_authid(id, authid, charsmax(authid))
	
	new vaultkey[64], vaultdata[64]
	format(vaultkey, charsmax(vaultkey), "TIMEPLAYED%s", authid)
	nvault_get(valut, vaultkey, vaultdata, charsmax(vaultdata))

	return str_to_num(vaultdata);
}

SaveTime(id, PlayedTime)
{	
	new authid[35]
	get_user_authid(id, authid, charsmax(authid))
	
	new vaultkey[64], vaultdata[64]
	format(vaultkey, charsmax(vaultkey), "TIMEPLAYED%s", authid)
	format(vaultdata, charsmax(vaultdata), "%i", PlayedTime); 
	
	nvault_set(valut, vaultkey, vaultdata);
}
